//
//  GetHTMLSource.m
//  KotnetAutologin
//
//  Created by Kristof Marien on 4/01/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "GetHTMLSource.h"


@implementation GetHTMLSource

@synthesize url;
@synthesize delegate;
@synthesize receivedCallback;
@synthesize errorCallback;

- (void)terminate {
	[theConnection cancel];
	[theConnection release];
	[receivedData release];
	[url release];
	[delegate release];
}
- (void) getSource:(id)requestDelegate receivedSelector:(SEL)receivedSelector errorSelector:(SEL)errorSelector
{
	self.delegate = requestDelegate;
	self.receivedCallback = receivedSelector;
	
	if (self.url == @"") {
		NSLog(@"Error - Please enter a URL.");
		return;
	}
	theRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:self.url]
											  cachePolicy:NSURLRequestUseProtocolCachePolicy
										  timeoutInterval:60.0];
	theConnection = [NSURLConnection alloc];
	[theConnection initWithRequest:theRequest delegate:self];
	if (theConnection) {
		receivedData = [NSMutableData alloc];
	} else {
		if (self.delegate && self.errorCallback) {
			if ([self.delegate respondsToSelector:self.errorCallback]) {
				[self.delegate performSelector:self.errorCallback];
			}
		}
	}
}
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    [receivedData setLength:0];
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [receivedData appendData:data];
}
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
	if (self.delegate && self.errorCallback) {
		if ([self.delegate respondsToSelector:self.errorCallback]) {
			[self.delegate performSelector:self.errorCallback];
		}
	}
	[self terminate];
}
- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
	if (self.delegate && self.receivedCallback) {
		if ([self.delegate respondsToSelector:self.receivedCallback]) {
			NSString *source = [[NSString alloc] initWithData:receivedData encoding:NSASCIIStringEncoding];
			[self.delegate performSelector:self.receivedCallback withObject:source];
			[source release];
		}
	}
	[self terminate];
}
@end
