//
//  Preferences.m
//  KotnetAutologin
//
//  Created by Kristof Marien on 31/12/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Preferences.h"


@implementation Preferences
- (IBAction)showPreferencesPanel:(id)sender 
{
	[NSApp activateIgnoringOtherApps:YES];
	// We always show the same preferences panel. Its controller doesn't get deallocated when the user closes it.
    if (!_preferencesPanelController) {
		_preferencesPanelController = [[NSWindowController alloc] initWithWindowNibName:@"Preferences"];
		
		// Make the panel appear in a good default location.
		[[_preferencesPanelController window] center];
		
    }
    [_preferencesPanelController showWindow:sender];
}
- (void)awakeFromNib
{
	keyChain = [KeyChain alloc];
	NSString *user = [[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:@"userName"];
	void *password = [keyChain getPasswordKeyChain:user];
	if (password != "not found PWD") {
		NSString *pwd = [NSString stringWithUTF8String:password];
		[passwordTextField setStringValue:pwd];
	} else {
		[passwordTextField setStringValue:@""];
		[userTextField setStringValue:@""];
	}
	[keyChain dealloc];
}
- (BOOL)windowShouldClose:(id)sender
{
	if ([startAtLoginCheckBox state]) {
		NSDictionary *errorDict;
		NSAppleScript *scriptObject = [[NSAppleScript alloc] initWithSource:
									   @"\
									   set app_path to path to me\n\
									   tell application \"System Events\"\n\
									   if \"AddLoginItem\" is not in (name of every login item) then\n\
									   make login item at end with properties {hidden:false, path:app_path}\n\
									   end if\n\
									   end tell"];
		[scriptObject executeAndReturnError: &errorDict];
		[scriptObject release];
		[errorDict release];
	}
	return [self saveLogin:sender];
}
- (BOOL) saveLogin:(id)sender
{
	keyChain = [KeyChain alloc];
	if ([saveInKeychainCheckBox state]) {
		if ([userTextField stringValue] == @"" || [passwordTextField stringValue] == @"") {
			[self displayAlertWithMessageText:@"Gelieve een gebruikersnaam en wachtwoord in te vullen.":sender];
			return NO;
		}
		[keyChain savePassWordKeyChain:[userTextField stringValue] 
											  :[passwordTextField stringValue]];
	} else {
		[keyChain deletePasswordKeyChain:[userTextField stringValue]];
	}
	[keyChain dealloc];
	return YES;
}
- (void)displayAlertWithMessageText:(NSString *)messageText:(id)sender
{
	NSAlert *alert = [[[NSAlert alloc] init] autorelease];
	[sender setAlphaValue:1.0];
	[alert addButtonWithTitle:@"Ok"];
	[alert setMessageText:@"Foutmelding"];
	[alert setInformativeText:messageText];
	[alert setAlertStyle:NSWarningAlertStyle];
	[alert beginSheetModalForWindow:sender modalDelegate:self didEndSelector:nil contextInfo:nil];
}
@end
